
; NORMAL
; ix = le sprite a afficher
; a = x
; e = y
draw_sprite_16x16:

	; y * 12
	ld	hl, 0
	ld	d, 0
	add	hl, de	; 1
	add	hl, de	; 2
	add	hl, de	; 3
	add	hl, hl	; 6
	add	hl, hl	; 12
	
	; x / 8
	ld	d, 0
	ld	e, a
	srl	e	; / 2
	srl	e	; / 4
	srl	e	; / 8
	add	hl, de

	; a present on a le decalage dans hl
	ld	de, (pointeur_sur_buffer)	; prendre le debut du graphbuffer
	add	hl, de		; puis ajouter le decalage

	ld      b,00000111b     ; le reste 
	and     b
	ld	c, a		; sauver dans c
	cp      0               ; tester l'alignement en x 
	jp      z,ds16_aligne
	jp	ds16_non_aligne

	
ds16_aligne:
	ld	b, 16	; sprite 8 de hauteur
ds16_aligne_loop:
	push	bc
	ld	a, (ix)
	and	(hl)
	ld	(hl), a
	inc	hl
	inc	ix
	ld	a, (ix)
	and	(hl)
	ld	(hl), a
	inc	ix
	ld	de, 11
	add	hl, de 
	pop	bc
	djnz	ds16_aligne_loop

	jp	ds16_fin

; c= decalage
ds16_non_aligne:
	ld	b, 16
ds16_non_aligne_loop:
	push	bc
	ld	b, c	; on va utiliser le nombre de rotations comme compteur
	ld	a, (ix)	; l'octet qu'il faut decaler 
	inc	ix
	ld	e, (ix)
	inc	ix
	ld	d, 0

ds16_shift_loop:
	push	bc	; ici on sauve en meme temps le compteur b et le decalage c
	srl	a	; decaler a vers la droite et ce qui sort va en carry
	rr	e	; injecter la carry dans e
	rr	d
	pop	bc
	djnz	ds16_shift_loop
	
	and	(hl)
	ld	(hl), a	; ecrire le premier octet
	inc	hl	; avancer d'un cran
	ld	a, e	
	and	(hl)
	ld	(hl), a ; ecrire le second octet
	inc	hl	; avancer d'un cran
	ld	a, d	
	and	(hl)
	ld	(hl), a ; ecrire le troisieme octet

	ld	de, 10
	add	hl, de 
	
	pop	bc
	djnz	ds16_non_aligne_loop
	
ds16_fin:
	ret





; AND
; ix = le sprite a afficher
; a = x
; e = y
draw_sprite_and_16x16:

	; y * 12
	ld	hl, 0
	ld	d, 0
	add	hl, de	; 1
	add	hl, de	; 2
	add	hl, de	; 3
	add	hl, hl	; 6
	add	hl, hl	; 12
	
	; x / 8
	ld	d, 0
	ld	e, a
	srl	e	; / 2
	srl	e	; / 4
	srl	e	; / 8
	add	hl, de

	; a present on a le decalage dans hl
	ld	de, (pointeur_sur_buffer)	; prendre le debut du graphbuffer
	add	hl, de		; puis ajouter le decalage

	ld      b,00000111b     ; le reste 
	and     b
	ld	c, a		; sauver dans c
	cp      0               ; tester l'alignement en x 
	jp      z,dsa16_aligne
	jp	dsa16_non_aligne

	
dsa16_aligne:
	ld	b, 16	; sprite 8 de hauteur
dsa16_aligne_loop:
	push	bc
	ld	a, (ix)
	and	(hl)
	ld	(hl), a
	inc	hl
	inc	ix
	ld	a, (ix)
	and	(hl)
	ld	(hl), a
	inc	ix
	ld	de, 11
	add	hl, de 
	pop	bc
	djnz	dsa16_aligne_loop

	jp	dsa16_fin

; c= decalage
dsa16_non_aligne:
	ld	b, 16
dsa16_non_aligne_loop:
	push	bc
	ld	b, c	; on va utiliser le nombre de rotations comme compteur
	ld	a, (ix)	; l'octet qu'il faut decaler 
	inc	ix
	ld	e, (ix)
	inc	ix
	ld	d, 0

dsa16_shift_loop:
	push	bc	; ici on sauve en meme temps le compteur b et le decalage c
	srl	a	; decaler a vers la droite et ce qui sort va en carry
	rr	e	; injecter la carry dans e
	rr	d
	pop	bc
	djnz	dsa16_shift_loop
	
	and	(hl)
	ld	(hl), a	; ecrire le premier octet
	inc	hl	; avancer d'un cran
	ld	a, e	
	and	(hl)
	ld	(hl), a ; ecrire le second octet
	inc	hl	; avancer d'un cran
	ld	a, d	
	and	(hl)
	ld	(hl), a ; ecrire le troisieme octet

	ld	de, 10
	add	hl, de 
	
	pop	bc
	djnz	dsa16_non_aligne_loop
	
dsa16_fin:
	ret




; OR
; ix = le sprite a afficher
; a = x
; e = y
draw_sprite_or_16x16:

	; y * 12
	ld	hl, 0
	ld	d, 0
	add	hl, de	; 1
	add	hl, de	; 2
	add	hl, de	; 3
	add	hl, hl	; 6
	add	hl, hl	; 12
	
	; x / 8
	ld	d, 0
	ld	e, a
	srl	e	; / 2
	srl	e	; / 4
	srl	e	; / 8
	add	hl, de

	; a present on a le decalage dans hl
	ld	de, (pointeur_sur_buffer)	; prendre le debut du graphbuffer
	add	hl, de		; puis ajouter le decalage

	ld      b,00000111b     ; le reste 
	and     b
	ld	c, a		; sauver dans c
	cp      0               ; tester l'alignement en x 
	jp      z,dso16_aligne
	jp	dso16_non_aligne

	
dso16_aligne:
	ld	b, 16	; sprite 8 de hauteur
dso16_aligne_loop:
	push	bc
	ld	a, (ix)
	or	(hl)
	ld	(hl), a
	inc	hl
	inc	ix
	ld	a, (ix)
	or	(hl)
	ld	(hl), a
	inc	ix
	ld	de, 11
	add	hl, de 
	pop	bc
	djnz	dso16_aligne_loop

	jp	dso16_fin

; c= decalage
dso16_non_aligne:
	ld	b, 16
dso16_non_aligne_loop:
	push	bc
	ld	b, c	; on va utiliser le nombre de rotations comme compteur
	ld	a, (ix)	; l'octet qu'il faut decaler 
	inc	ix
	ld	e, (ix)
	inc	ix
	ld	d, 0

dso16_shift_loop:
	push	bc	; ici on sauve en meme temps le compteur b et le decalage c
	srl	a	; decaler a vers la droite et ce qui sort va en carry
	rr	e	; injecter la carry dans e
	rr	d
	pop	bc
	djnz	dso16_shift_loop
	
	or	(hl)
	ld	(hl), a	; ecrire le premier octet
	inc	hl	; avancer d'un cran
	ld	a, e	
	or	(hl)
	ld	(hl), a ; ecrire le second octet
	inc	hl	; avancer d'un cran
	ld	a, d	
	or	(hl)
	ld	(hl), a ; ecrire le troisieme octet

	ld	de, 10
	add	hl, de 
	
	pop	bc
	djnz	dso16_non_aligne_loop
	
dso16_fin:
	ret







; ix = le sprite a afficher
; a = x
; e = y
draw_sprite_xor_16x16:

	; y * 12
	ld	hl, 0
	ld	d, 0
	add	hl, de	; 1
	add	hl, de	; 2
	add	hl, de	; 3
	add	hl, hl	; 6
	add	hl, hl	; 12
	
	; x / 8
	ld	d, 0
	ld	e, a
	srl	e	; / 2
	srl	e	; / 4
	srl	e	; / 8
	add	hl, de

	; a present on a le decalage dans hl
	ld	de, (pointeur_sur_buffer)	; prendre le debut du graphbuffer
	add	hl, de		; puis ajouter le decalage

	ld      b,00000111b     ; le reste 
	and     b
	ld	c, a		; sauver dans c
	cp      0               ; tester l'alignement en x 
	jp      z,dsx16_aligne
	jp	dsx16_non_aligne

	
dsx16_aligne:
	ld	b, 16	; sprite 8 de hauteur
dsx16_aligne_loop:
	push	bc
	ld	a, (ix)
	xor	(hl)
	ld	(hl), a
	inc	hl
	inc	ix
	ld	a, (ix)
	xor	(hl)
	ld	(hl), a
	inc	ix
	ld	de, 11
	add	hl, de 
	pop	bc
	djnz	dsx16_aligne_loop

	jp	dsx16_fin

; c= decalage
dsx16_non_aligne:
	ld	b, 16
dsx16_non_aligne_loop:
	push	bc
	ld	b, c	; on va utiliser le nombre de rotations comme compteur
	ld	a, (ix)	; l'octet qu'il faut decaler 
	inc	ix
	ld	e, (ix)
	inc	ix
	ld	d, 0

dsx16_shift_loop:
	push	bc	; ici on sauve en meme temps le compteur b et le decalage c
	srl	a	; decaler a vers la droite et ce qui sort va en carry
	rr	e	; injecter la carry dans e
	rr	d
	pop	bc
	djnz	dsx16_shift_loop
	
	xor	(hl)
	ld	(hl), a	; ecrire le premier octet
	inc	hl	; avancer d'un cran
	ld	a, e	
	xor	(hl)
	ld	(hl), a ; ecrire le second octet
	inc	hl	; avancer d'un cran
	ld	a, d	
	xor	(hl)
	ld	(hl), a ; ecrire le troisieme octet

	ld	de, 10
	add	hl, de 
	
	pop	bc
	djnz	dsx16_non_aligne_loop
	
dsx16_fin:
	ret



	
	
